<?
abstract class Chat
{
	var $kernel;

	function __construct($kr)
	{
		$this->kernel = & $kr;
	}

	function Login()
	{
		$this->kernel->db->connect();
		$this->kernel->session->start();
		if($this->kernel->session->logined())
		{
			switch (isset($_GET['type']) ? $_GET['type'] : 'default')
			{
				case 'send':
					$this->Send();
					break;
				case 'load':
					$this->Load();
					break;
				case 'online':
					$this->Online();
					break;
				default:
					$this->Content();
			}
		}
		else
		{
			if(isset($_GET['type']))
			{
				include_once(ELFCHAT_PATH."classes/JsHttpRequest.php");
				$JsHttpRequest =& new JsHttpRequest("UTF-8");
				global $_RESULT;
				
				$_RESULT = array(
				"out"  =>  $this->kernel->settings['outlink'],
				);
			}
			else
			{
				@elfchat_error('nosession');
			}
		}
		$this->kernel->db->close();
	}

	function Content() { }
	function Send() { }
	function Load() { }
	function Online() { }

	function TextPreform($text)
	{
		//xss security
		$text = htmlspecialchars($text);
		
		$text = preg_replace( "/javascript/i" , "j&#097;v&#097;script", $text);

		$text = preg_replace( "/alert/i"      , "&#097;lert"         	, $text );
		$text = preg_replace( "/about:/i"     , "&#097;bout:"         	, $text );
		$text = preg_replace( "/onmouseover/i", "&#111;nmouseover"    	, $text );
		$text = preg_replace( "/onclick/i"    , "&#111;nclick"        	, $text );
		$text = preg_replace( "/onload/i"     , "&#111;nload"         	, $text );
		$text = preg_replace( "/onsubmit/i"   , "&#111;nsubmit"       	, $text );
        $text = preg_replace( "/onmouseout/i" , "&#111;nmouseout"		, $text );
        $text = preg_replace( "/onunload/i"   , "&#111;nunload"   		, $text );
        $text = preg_replace( "/onabort/i"    , "&#111;nabort"    		, $text );
        $text = preg_replace( "/onerror/i"    , "&#111;nerror"    		, $text );
        $text = preg_replace( "/onblur/i"     , "&#111;nblur"     		, $text );
        $text = preg_replace( "/onchange/i"   , "&#111;nchange"   		, $text );
        $text = preg_replace( "/onfocus/i"    , "&#111;nfocus"    		, $text );
        $text = preg_replace( "/onreset/i"    , "&#111;nreset"    		, $text );
        $text = preg_replace( "/ondblclick/i" , "&#111;ndblclick" 		, $text );
        $text = preg_replace( "/onkeydown/i"  , "&#111;nkeydown"  		, $text );
        $text = preg_replace( "/onkeypress/i" , "&#111;nkeypress" 		, $text );
        $text = preg_replace( "/onkeyup/i"    , "&#111;nkeyup"    		, $text );
        $text = preg_replace( "/onmousedown/i", "&#111;nmousedown"		, $text );
        $text = preg_replace( "/onmouseup/i"  , "&#111;nmouseup"  		, $text );
        $text = preg_replace( "/onselect/i"   , "&#111;nselect"   		, $text );		
		
		
		$text = nl2br($text);
		$text = hrefActivate($text);
		
		return $text;
	}

}

// Функция обратного вызова для preg_replace_callback().
function hrefCallback($p) {
	// Преобразуем спецсимволы в HTML-представление.
	$name = $p[0];//htmlspecialchars($p[0]);
	// Если нет протокола, добавляем его в начало строки.
	$href = !empty($p[1])? $name : "http://$name";
	// Формируем ссылку.
	return "<a href=\"$href\" target=\"_blank\">$name</a>";
}

// Заменяет ссылки на их HTML-эквиваленты ("подчеркивает ссылки").
function hrefActivate($text) {
	return preg_replace_callback(
	'{
      (?:
        (\w+://)          # протокол с двумя слэшами
        |                 # - или -
        www\.             # просто начинается на www
      )
      [\w-]+(\.[\w-]+)*   # имя хоста
      (?: : \d+)?         # порт (не обязателен)
      [^<>"\'()\[\]\s]*   # URI (но БЕЗ кавычек и скобок)
      (?:                 # последний символ должен быть...
          (?<! [[:punct:]] )  # НЕ пунктуацией
        | (?<= [-/&+*]     )  # но допустимо окончание на -/&+*
      )
    }xis',
    "hrefCallback",
    $text
    );
}
?>