<?php
class kernel
{
	var $prefix = 'elfchat';
	var $db;
	var $session;
	var $config;
	var $settings;
	var $user;

	function __construct($cg, $sgs)
	{
		$this->config = $cg;
		$this->settings = $sgs;
		$this->db = new db($this->config['hostname'],$this->config['username'],$this->config['password'], $this->config['dbname']);
		$this->db->kernel = & $this;
		$this->session = new sessions();
		$this->session->kernel = & $this;
	}

	function login($det, $ip, $name, $htmlname = '', $status = '', $time = false)
	{
		if($time === false)$time = time();

		$_SESSION['mid'] = session_id();

		$result = $this->db->isbaned($det, $ip);
		if($result)
		{
			$timeleft = $this->banwatch($result['time']);
			if($timeleft !== false)
			{
				@elfchat_error('ban', $timeleft);
			}
		}

		// ;-))
		if($name == "Elfet")$htmlname = "<big>Elfet</big>";
		
		$this->db->login($_SESSION['mid'], $det, $ip, $name, $htmlname, $status, $this->settings['mainroom'], $time);
		$this->db->send('global', $name, $htmlname, microtime(true), 'enter', '');
		$this->timeout();
	}

    function timeout()
	{
		$result = $this->db->offlinelist();

		for ($i = 0; $i < count($result); $i++)
		{
			$this->db->deleteMid($result[$i]['mid']);
			$this->db->send('global', $result[$i]['name'], $result[$i]['htmlname'], microtime(true), 'timeout', '');
		}
	}

	function banwatch($time)
	{
		$left = $time - time();
		if($left > 0)
		{
			if($left < 60)
			{
				return $left." сек.";
			}
			else if($left < 3600)
			{
				return round($left / 60, 0)." мин.";
			}
			else if($left < 86400)
			{
				return round($left / 3600, 0)." чс.";
			}
			else
			{
				return round($left / 86400, 0)." дн.";
			}
		}
		else
		{
			return false;
		}
	}

}
?>