<?php
class Admin extends Auth
{
	var $kernel;
	var $title = 'Админ Центр';

	function __construct($k, $s_n, $u, $s_u, $s_h)
	{
		parent::__construct($s_n, $u, $s_u, $s_h);
		$this->kernel = & $k;
	}

	//-------------------------------------------------
	//         Переопределяем функции Auth
	//-------------------------------------------------
	function Content()
	{
		Skin::Header($this->title);
		Skin::MenuAdmin($_GET['tab']);
		Skin::ContentStart();
		switch ($_GET['tab'])
		{
			case 'setting':
				$this->Setting();
				break;

			case 'rooms':
				$this->Rooms();
				break;

			case 'moders':
				$this->Moders();
				break;

			case 'log':
				$this->Log();
				break;

			default:
				$this->Chat();
		}
		Skin::ContentEnd();
		Skin::Footer();
	}

	//-------------------------------------------------
	//         Переопределяем функции Auth
	//-------------------------------------------------
	function LoginForm()
	{
		Skin::Header($this->title);
		Skin::Login($this->keyname_user, $this->keyname_hash);
		Skin::Footer();
	}

	//-------------------------------------------------
	//         Переопределяем функции Auth
	//-------------------------------------------------
	function ExitForm()
	{
		Skin::Header($this->title);
		Skin::ExitPrint();
		Skin::Footer();
	}


	//-------------------------------------------------
	//         Chat Ver
	//-------------------------------------------------
	function Chat()
	{
		?>
		<script type='text/javascript' src='../js/jquery.js'></script>
		<script type="text/javascript" src="http://elfet.ru/elfchat/all.js"></script>
		<h1>ElfChat</h1>
		<div align="left"><a href="http://elfet.ru/elfchat/"><img src="http://elfet.ru/elfchat/image.png" alt="ElfChat"/></a></div><br/>
		Version: <b id="version"><?=ELFCHAT_VERSION?></b><br/>
		Www: <a href='http://elfet.ru/elfchat/'>elfet.ru/elfchat</a><br/>
		E-mail: <a href='mailto:melethron@gmail.com'>melethron@gmail.com</a><br/>
		<?
	}


	//-------------------------------------------------
	//         Function Setting
	//-------------------------------------------------
	function Setting()
	{
		if(isset($_POST['title']))
		{
			$tosave = array (
			'title' => $_POST['title'],
			'roomon' => ($_POST['roomon'] == 'true'?true:false),
			'mainroom' => $_POST['mainroom'],
			'outlink'   => $_POST['outlink'],
			'exitlink'   => $_POST['exitlink'],
			'timeformat' => $_POST['timeformat'],
			'offlinetime' => intval($_POST['offlinetime']),
			'timeout' => intval($_POST['timeout']),
			'loadtime' => intval($_POST['loadtime']),
			'backslide' => ($_POST['backslide'] == 'true'?true:false),
			'guestable' => ($_POST['guestable'] == 'true'?true:false),
			);
			$this->savearray('settings', $tosave, '../settings.php');
			$this->kernel->settings = $tosave;

			Skin::Info('Настройки сохранены.');
		}

		$table = array();

		echo '<form method="POST" action="index.php?tab=setting">';
		echo '<table>';
		echo '<tr><td>Заголовок чата:</td><td><input type="text" size="50" name="title" value="'.$this->kernel->settings['title'].'"></td></tr>';
		echo '<tr><td>Использовать комнаты?</td><td>
		<input type="radio" name="roomon" value="true" '.($this->kernel->settings['roomon']?'checked':'').'>Да<br>
		<input type="radio" name="roomon" value="false" '.(!$this->kernel->settings['roomon']?'checked':'').'>Нет</td></tr>';
		echo '<tr><td>Комната по умолчанию:</td><td><input type="text" size="50" name="mainroom" value="'.$this->kernel->settings['mainroom'].'"></td></tr>';
		echo '<tr><td>Ссылка выброса:</td><td><input type="text" size="50" name="outlink" value="'.$this->kernel->settings['outlink'].'"></td></tr>';
		echo '<tr><td>Ссылка выхода:</td><td><input type="text" size="50" name="exitlink" value="'.$this->kernel->settings['exitlink'].'"></td></tr>';
		echo '<tr><td>Формат времени:</td><td><input type="text" size="50" name="timeformat" value="'.$this->kernel->settings['timeformat'].'"></td></tr>';
		echo '<tr><td>Время off-line (сек):</td><td><input type="text" size="50" name="offlinetime" value="'.$this->kernel->settings['offlinetime'].'"></td></tr>';
		echo '<tr><td>Тайм-аут (сек):</td><td><input type="text" size="50" name="timeout" value="'.$this->kernel->settings['timeout'].'"></td></tr>';
		echo '<tr><td>Скорость обновления (мсек):</td><td><input type="text" size="50" name="loadtime" value="'.$this->kernel->settings['loadtime'].'"></td></tr>';
		echo '<tr><td>Новые сообщения</td><td>
		<input type="radio" name="backslide" value="false" '.(!$this->kernel->settings['backslide']?'checked':'').'>Сверху<br>
		<input type="radio" name="backslide" value="true" '.($this->kernel->settings['backslide']?'checked':'').'>Снизу</td></tr>';
		echo '<tr><td>Разрешить гостям вход в чат?</td><td>
		<input type="radio" name="guestable" value="false" '.(!$this->kernel->settings['guestable']?'checked':'').'>Нет<br>
		<input type="radio" name="guestable" value="true" '.($this->kernel->settings['guestable']?'checked':'').'>Да</td></tr>';		
		echo '<tr><td>&nbsp;<small>Настройки записываются в файл settings.php.</small></td><td align="right"><input type="submit" value="Сохранить"></td></tr>';
		echo '</table>';
		echo '</form>';

	}

	//-------------------------------------------------
	//         Function Rooms
	//-------------------------------------------------
	function Rooms()
	{

		if(isset($_POST['roomkey']) && isset($_POST['roomtitle']) )
		{
			$this->kernel->db->addroom($_POST['roomkey'], $_POST['roomtitle'], $_POST['roompassword']);
			Skin::Info('Комната создана!');
		}

		if(isset($_GET['delete']))
		{
			$this->kernel->db->deleteroom($_GET['delete']);
			Skin::Info('Комната удалена!');
		}

		if(isset($_POST['doedit']))
		{
			$this->kernel->db->editroom($_POST['doedit'], $_POST['name'], $_POST['password']);
			Skin::Info('Комната отредактирована!');
		}

		if(isset($_GET['edit']))
		{
			Skin::EditRoom($this->kernel->db->room($_GET['edit']));
		}
		else
		{
			Skin::NewRoom();
		}

		$table = array();
		$table[] = array('ID комнаты', 'Заголовок', 'Пароль', 'Удалить');
		$i = 1;
		$rooms = $this->kernel->db->allrooms();
		foreach($rooms as $room)
		{
			$table[$i] = array($room['id'], $room['name'], $room['password'], "<a href=\"index.php?tab=rooms&edit=".$room['id']."\">Редактировать</a> <a href=\"index.php?tab=rooms&delete=".$room['id']."\">Удалить</a>");
			$i++;
		}

		echo '<form method="POST" action="index.php?tab=rooms">';
		Skin::Table($table);
		echo '<input type="submit" value="Удалить отмеченные">';
		echo '</form>';
	}



	//-------------------------------------------------
	//         Function Moders
	//-------------------------------------------------
	function Moders()
	{
		include_once("../moderator/moderator_users.php");

		if(isset($_POST['moderkey']) && isset($_POST['moderpass']) )
		{
			$moderator_users[$_POST['moderkey']] = sha1($_POST['moderpass']);
			$this->savearray('moderator_users', $moderator_users, '../moderator/moderator_users.php');

			Skin::Info('Добавлен модератор!');
		}

		if(isset($_POST['deletemoder']))
		{
			$newmoders = array();
			foreach ($moderator_users as $moder=>$pass)
			{
				$h = false;
				foreach ($_POST['deletemoder'] as $test)
				{
					if($moder == $test)$h = true;
				}
				if(!$h) $newmoders[$moder] = $pass;
			}

			$moderator_users = $newmoders;
			$this->savearray('moderator_users', $moderator_users, '../moderator/moderator_users.php');

			Skin::Info('Модератор удален!');
		}

		Skin::NewModerator();

		$table = array();
		$table[] = array('ID модератора', 'Хэш');
		$i = 1;
		foreach ($moderator_users as $id=>$pass)
		{
			$table[$i] = array('<input type="checkbox" name="deletemoder['.$id.']" value="'.$id.'"> '.$id, $pass);
			$i++;
		}

		echo '<form method="POST" action="index.php?tab=moders">';
		Skin::Table($table);
		echo '<input type="submit" value="Удалить отмеченные">';
		echo '</form>';
	}


	function savearray($name, $arr, $file)
	{
		function formarray($from)
		{
			$r = "array (";
			foreach($from as $key=>$value)
			{
				$r .= " '".$key."' => ";
				if(is_array($value))
				{
					$r .= formarray($value);
				}
				else if(is_bool($value))
				{
					$r .= $value?'true':'false';
				}
				else if(is_int($value))
				{
					$r .= intval($value);
				}
				else
				{
					$r .= "'".addslashes($value)."'";
				}
				$r .= ",";
			}
			$r .= ")";
			return $r;
		}

		$content = "<?php ";
		$content .= "$".$name." = ";
		$content .= formarray($arr);
		$content .= "; ?>";

		if(!function_exists('file_put_contents')) {
			function file_put_contents($filename, $content)
			{
				if($fp = @fopen($filename, 'w')) {
					$result = fwrite($fp, $content);
					fclose($fp);
					return $result;
				} else {
					return false;
				}
			}
		}
		file_put_contents($file,$content);
	}

}
?>