<?php
define( 'ELFCHAT_PATH'  , "./" );
include_once("kernel/elfchat.php");
include_once("classes/chat.php");
include_once("skin/skin_main.php");

class Help
{
	private $kernel;
	function __construct($kr)
	{
		$this->kernel = & $kr;
	}

	function Load()
	{
		$scripts = "
		  <script type='text/javascript' src='js/jquery.js'></script>
		".$html;
		Skin::Header(array(
		"title" => " - Помощь",
		"settings" => $this->kernel->settings,
		"scripts" => $scripts,
		"chattype" => "help",
		"det" => "default",
		"showExitLink" => false,
		));
		Skin::Help(
		"Как отправить личное/приватное сообщение?",
		"Нажмите на кнопку <img src='skin/privat.png'/> рядом с именем пользователя. Откроется окно для приватного чата с этим пользователем. В какой он комнате - не важно. Он всегда сможет получить ваше сообщение."
		);	
		Skin::Help(
		"Как отличить гостя в чате от не гостя?",
		"Обычно имя гостя пишутся курсивом: <i>Гость</i> в отличии от негостя: Не гость"
		);					
		Skin::Help(
		"Что такое спящий режим?",
		"Если вы хотите отойти куда-нибудь, но не хотите выходить из чата, то включите спящий режим. В этом режиме обращения к серверу происходят намного реже."
		);		
		Skin::Help(
		"Что такое тайм-аут?",
		"Это время бездействия после которого вас выкинут из чата. Что бы этого не происходило, всегда перед выходом из чата нажимайте Выход(!) <img src='skin/bexit.png'/>"
		);
		Skin::Help(
		"Что такой статус?",
		"Статус - текст напротив вашего ника. По умолчанию статус отображает <i>On-line или Off-line</i>, что говорит остальным пользователям в чате вы или нет. 
		Статус можно задать произвольный."
		);		
		Skin::Help(
		"Как изменить свой статус?",
		"Для этого напишите <i>%ваш статус</i>. Что бы удалить его напишите только знак процента <i>%</i>."
		);
		Skin::Help(
		"Как перейти на новую строчку при наборе сообщения?",
		"Для перехода на новую строчку нажмите: <i>Shift + Enter</i>"
		);			
		Skin::Help(
		"Как получить модераторские права в чате?",
		"Для этого администратор в панели управления чатом должен добавить модератора с вашем ID(с форума, сайта, ext) и произвольным паролем. Затем вам нужно отправить в чате сообщение <i>@me</i> и ввести свой пароль в появившемся окне."
		);		
		Skin::Help(
		"Где взять такой чат себе?",
		"Тут: <a href=\"http://elfet.ru/elfchat/\">http://elfet.ru/elfchat/</a>"
		);
		Skin::FooterStill();
	}


}

$char = new Help($kernel);
$char->Load();


