<?php
define( 'ELFCHAT_PATH'  , "./" );

Header('Content-Type: text/html; charset=utf-8');

Skin::Header('Установка ElfChat');
Skin::ContentStart();
switch ($_GET['g'])
{
	case 'global':
		print(globalconf());
		break;

	case 'writeglobal':
		print(writeglobal());
		break;

	case 'sql':
		print(sql());
		break;

	case 'admin':
		print(admin());
		break;

	case 'writeadmin':
		print(writeadmin());
		break;

	case 'end':
		print(ender());
		break;

	default:
		print(hello());
}
Skin::ContentEnd();
Skin::Footer();

function file_perms($file, $octal = false)
{
	if(!file_exists($file)) return false;

	$perms = fileperms($file);

	$cut = $octal ? 2 : 3;

	return substr(decoct($perms), $cut);
}


function hello()
{
	$errors = "";

	foreach(array("config.php", "settings.php", "moderator/moderator_users.php", "admin/admin_users.php") as $file)
	{
		@chmod($file, 0777);
		$prem = file_perms($file);
		if($prem != "777")
		{
			$errors .= "У файла <b>$file</b> права: <b>$prem</b>. Для установки чата необходимо дать ему права 777.<br>";
		}
	}

	if($errors != "")
	{
		?>
		<b>Внимание!</b><br/>
		<?=$errors?><br/>
		<?
	}
	
?>
Для интеграции с форумом вы должны были выполнить инструкции в одной из папок: ipb/, vbulletin/, phpbb/, punbb/, ...
	<div align="center">
	 <big>Приступить к установке:</big><br>
   	    <form action='install.php?g=global' method='POST'>
		&nbsp;<input type='submit' value='Шаг 1. Основные настройки.'>
		</form>
		<br>
		<form action='install.php?g=sql' method='POST'>
		&nbsp;<input type='submit' value='Шаг 2. Создание таблиц в БД.'>
		</form>
		<br>
		<form action='install.php?g=admin' method='POST'>
		&nbsp;<input type='submit' value='Шаг 3. Создание администратора.'>
		</form>		
	</div>
<?
}

function globalconf()
{
?>
	<form action='install.php?g=writeglobal' method='POST'>
	<table>
	<tr><td>Хост</td><td><input type="text" name="hostname" value="localhost"></td></tr>
	<tr><td>Пользователь БД</td><td><input type="text" name="username" value="root"></td></tr>
	<tr><td>Пароль БД</td><td><input type="text" name="password"></td></tr>
	<tr><td>Имя базы данных</td><td><input type="text" name="dbname" value="elfchat"></td></tr>
	</table>
	<br>
	<input type='submit' value='Далее'>
	</form>
<?
}

function writeglobal()
{
	$config = array (
	'hostname' => mysql_escape_string($_POST['hostname']),
	'username' => mysql_escape_string($_POST['username']),
	'password' => mysql_escape_string($_POST['password']) ,
	'dbname' => mysql_escape_string($_POST['dbname']),
	);
	savearray('config', $config, 'config.php');
	Skin::Info('Настройки сохранены!');
?>
	<form action='install.php?g=sql' method='POST'>
	<input type='submit' value='Далее. Создание таблиц в БД.'>
	</form>
<?
}

function sql()
{
	include_once("./kernel/elfchat.php");
	$kernel->db->connect();

	// MySql
	mysql_query("CREATE TABLE ".$kernel->prefix."_messages (
  `id` int(10) NOT NULL auto_increment primary key,
  `room` char(255) NOT NULL default 'main',
  `fordet` char(64) NOT NULL default '',
  `fromdet` char(64) NOT NULL default '',
  `seen` int(2) NOT NULL default '0',
  `name` char(255) character set cp1251 collate cp1251_general_cs  NOT NULL default '',
  `htmlname` text character set cp1251 collate cp1251_general_cs  NOT NULL default '',
  `time` REAL NOT NULL default '0.0',
  `type` varchar(8) NOT NULL default 'msg',
  `msg` text character set cp1251 collate cp1251_general_cs NOT NULL default '') DEFAULT CHARSET=utf8;", $kernel->db->id);
	mysql_query("CREATE TABLE ".$kernel->prefix."_users (
  `id` int(10) NOT NULL auto_increment primary key,
  `mid` char(32) NOT NULL default '',
  `det` char(64) NOT NULL default '',
  `ip` char(32) NOT NULL default '',
  `room` char(255) NOT NULL default 'main',
  `name` char(255) character set cp1251 collate cp1251_general_cs  NOT NULL default '',
  `htmlname` text character set cp1251 collate cp1251_general_cs  NOT NULL default '',
  `status` char(255) NOT NULL default '',
  `time` int(10) NOT NULL default '0') DEFAULT CHARSET=utf8;", $kernel->db->id);	
	mysql_query("CREATE TABLE ".$kernel->prefix."_ban (
  `id` int(10) NOT NULL auto_increment primary key,
  `type` char(255) NOT NULL default 'id',
  `ban` char(64) NOT NULL default '',
  `comment` text character set cp1251 collate cp1251_general_cs  NOT NULL default '',
  `time` int(10) NOT NULL default '0') DEFAULT CHARSET=utf8;", $kernel->db->id);
	mysql_query("CREATE TABLE ".$kernel->prefix."_log (
  `id` int(10) NOT NULL auto_increment primary key,
  `name` char(255) character set cp1251 collate cp1251_general_cs NOT NULL default '',
  `comment` test character set cp1251 collate cp1251_general_cs  NOT NULL default '',
  `time` int(10) NOT NULL default '0') DEFAULT  CHARSET=utf8;", $kernel->db->id);
	mysql_query("CREATE TABLE `".$kernel->prefix."_rooms` (
   `id` varchar(255) NOT NULL,
   `name` text character set cp1251 collate cp1251_general_cs NOT NULL,
   `password` varchar(255) NOT NULL,
    KEY `id` (`id`)
    ) DEFAULT CHARSET=utf8;", $kernel->db->id);
	mysql_query("INSERT INTO `elfchat_rooms` VALUES ('main', 'ElfChat', '');", $kernel->db->id);

	Skin::Info('Таблицы созданы!');
    ?>
	<form action='install.php?g=admin' method='POST'>
	<input type='submit' value='Далее.'>
	</form>
    <?
    $kernel->db->close();
}


function admin()
{
?>
	<form action='install.php?g=writeadmin' method='POST'>
	<table>
	<tr><td>Админ</td><td><input type="text" name="admin" value="admin"></td></tr>
	<tr><td>Пароль</td><td><input type="text" name="password"></td></tr>
	</table>
	<h3>Другие настройки</h3>
	<table>
	<tr><td>Заголовок чата:</td><td><input type="text" size="50" name="title" value=""></td></tr>
	<tr><td>Ссылка выброса:</td><td><input type="text" size="50" name="outlink" value="http://yoursite/"><br/><small>Сюда после выброса будут перенаправляться пользователи.</small></td></tr>
	<tr><td>Ссылка выхода:</td><td><input type="text" size="50" name="exitlink" value="http://yoursite/"><br/><small>Сюда после выхода из чата будут перенаправляться пользователи.</small></td></tr>
	</table>
	<input type='submit' value='Далее'>
	</form>
<?
}

function writeadmin()
{
	include_once("settings.default.php");
	$tosave = array (
	'title' => $_POST['title'],
	'roomon' => $settings['roomon'],
	'mainroom' => $settings['mainroom'],
	'outlink'   => $_POST['outlink'],
	'exitlink'   => $_POST['exitlink'],
	'timeformat' => $settings['timeformat'],
	'offlinetime' => intval($settings['offlinetime']),
	'timeout' => intval($settings['timeout']),
	'loadtime' => intval($settings['loadtime']),
	'backslide' => $settings['backslide'],
	'guestable' => $settings['guestable'],
	);

	savearray('settings', $tosave, 'settings.php');

	$admin[$_POST['admin']] = sha1($_POST['password']);
	savearray('moderator_users', $admin, './moderator/moderator_users.php');
	savearray('admin_users', $admin, './admin/admin_users.php');

	Skin::Info('Настройки сохранены, админ добавлен.');
?>
	<form action='install.php?g=end' method='POST'>
	<input type='submit' value='Далее.'>
	</form>
<?
}

function ender()
{
	Skin::Info('Установка закончена');
?>
	<b>Теперь <big>необходимо</big> удалить install.php</b><br>
	<br>
	<a href="admin/">Зайдите в админку</a> настройте чат и добавьте модераторов.<br>
<?
}

function formarray($from)
{
	$r = "array (";
	foreach($from as $key=>$value)
	{
		$r .= " '".$key."' => ";
		if(is_array($value))
		{
			$r .= formarray($value);
		}
		else if(is_bool($value))
		{
			$r .= $value?'true':'false';
		}
		else if(is_int($value))
		{
			$r .= intval($value);
		}
		else
		{
			$r .= "'".addslashes($value)."'";
		}
		$r .= ",";
	}
	$r .= ")";
	return $r;
}


function savearray($name, $arr, $file)
{
	$content = "<?php ";
	$content .= "$".$name." = ";
	$content .= formarray($arr);
	$content .= "; ?>";

	if(!function_exists('file_put_contents')) {
		function file_put_contents($filename, $content)
		{
			if($fp = @fopen($filename, 'w')) {
				$result = fwrite($fp, $content);
				fclose($fp);
				return $result;
			} else {
				return false;
			}
		}
	}
	file_put_contents($file,$content);
}


class Skin
{
	//-------------------------------------------------
	//         Header
	//-------------------------------------------------
	function Header($title)
	{
?>
<html>
<html>
<head>
  <title><?=$title?></title>
  <meta http-equiv="content-type" content="text/html; charset=UTF-8">
  <style type="text/css">
  <!--
body {
    background-color: #F2F2F2;
    color: #222;
    font-family: Verdana, Tahoma, Arial, sans-serif;
    font-size: 14px;
    margin: 10px;
    padding: 0px; 
}

form {
    display: inline;
    margin: 0; 
    padding: 0; 
}

img {
    border: 0; 
    vertical-align: middle;
}

a:link,
a:visited,
a:active {
    color: #222;
    text-decoration: underline;
}

a:hover {
    color: #34498B;
}

td {
    color: #222;
    font-family: Verdana, Tahoma, Arial, sans-serif;
    font-size: 14px;
}

td.text {
    margin: 0; 
    padding: 10px; 
}

td.tabs {
    background-color: #B9DCFF;
    height: 25px;
}

a.tab {
    color: #FFFFFF;
    font-weight: bold;
    background-color: #0080FF;
    height: 25px;
    margin: 0px 0px 0px 10px; 
    padding: 5px 10px 0px 10px; 
    text-decoration: none;   
}

a.tab:hover {
    background-color: #AA80FF;
}

a.ontab {
    color: #0080FF;
    font-weight: bold;
    background-color: #FFFFFF;
    border-top: solid 1px #0080FF;
    border-left: solid 1px #0080FF;
    border-right: solid 1px #0080FF;
    height: 25px;
    margin: 0px 0px 0px 10px; 
    padding: 5px 10px 0px 10px; 
    text-decoration: none;   
}

.info {
    border: solid 1px #0080FF;
    background-color: #EFEFEF;
    padding: 10px;
}

.top {
    background-color: #B9DCFF;
}

.code {  
    font-family: Courier, "Courier New", Verdana, Arial;
	background: #FAFCFE; 
	border: 1px solid #000; 
	color: #465584; 
	font-family: Verdana, Arial; 
	font-size: 11px; 
	padding: 2px; 
	white-space: normal;
}

  -->
  </style>
</head>
<body>
<div align="center">
<table bgcolor="#FFFFFF" width="80%" cellspacing="0" cellpadding="0" border="0">
  <tr>
    <td class="text" bgcolor="#004080" height="30">
    <font size="2" color="#FFFFFF"><b><?=$title?></b></font>
    </td>
  </tr>
  <tr>
    <td bgcolor="#0080FF" height="4">
    </td>
  </tr>
<?	
	}


	//-------------------------------------------------
	//        ContentStart
	//-------------------------------------------------
	function ContentStart()
	{
?>		
  <tr>
	<td class="text" valign="top">
<?
	}

	//-------------------------------------------------
	//        ContentEnd
	//-------------------------------------------------
	function ContentEnd()
	{
?>		
	</td>
  </tr>
<?
	}





	//-------------------------------------------------
	//         Login
	//-------------------------------------------------
	function Info($msg)
	{
?>
    <h2 class="info"><?=$msg?></h2>
<?	
	}


	//-------------------------------------------------
	//         Table
	//-------------------------------------------------
	function Table($table)
	{
		?><table width="100%"><?
		foreach ($table as $k=>$row)
		{
			echo ($k == 0)? '<tr class="top">' : '<tr>';
			foreach ($row as $h)
			{
				if(is_array($h))
				{
					echo '<td '.$h[1].'>';
					echo $h[0];
				}
				else
				{
					echo '<td>';
					echo $h;
				}
				echo '</td>';
			}
			echo '</tr>';
		}
		?></table><?
	}




	//-------------------------------------------------
	//         Footer
	//-------------------------------------------------
	function Footer()
	{
?>
  <tr>
    <td bgcolor="#B9DCFF" height="30">
    <font size="2" color="#FFFFFF">&nbsp; <b>&copy;2008 <a href="http://elfet.ru/elfchat/" target="_blank">ElfChat</a> - Elfet</b></font>
    </td>
  </tr>
</table>
</div>
</body>
</html>
<?		
	}
}
?>