<?php
define( 'ELFCHAT_PATH'  , "./" );
include_once("kernel/elfchat.php");
include_once("classes/chat.php");
include_once("moderator/skin_moderator.php");

class Moderator extends Chat
{
	function __construct($kr)
	{
		parent::__construct($kr);
	}

	function Content()
	{
		if(isset($_SESSION['MODERATOR']) && $_SESSION['MODERATOR'] === true)
		{
			switch ($_REQUEST['tab'])
			{
				case 'del':
					$this->Del();
					break;
				case 'ban':
					$this->Ban();
					break;

				case 'msg':
					$this->Msg();
					break;
			}
		}
	}


	function Del()
	{
		if(isset($_POST['det']))
		{
			$user = $this->kernel->db->userByDet($_POST['det']);
			$this->kernel->db->send('global', $this->kernel->user['name'], $this->kernel->user['htmlname'], microtime(true), 'kill', $user['name']);
			$this->kernel->db->deleteDet($user['det']);

			Skin::Info($_POST['deleteName'].' удалён.');
		}
	}

	function Msg()
	{
		if(isset($_REQUEST['msg']))
		{
			$this->kernel->db->send('global', $this->kernel->user['name'], $this->kernel->user['htmlname'], microtime(true), 'global', $_REQUEST['msg']);
		}
		else
		{
			Skin::Header('Сообщение');
			Skin::MsgForm();
		}
	}

	function Ban()
	{
		//-------------------------------------------------
		//         List Or New Ban
		//-------------------------------------------------
		if(isset($_GET['det']) && isset($_GET['name']))
		{
			$user = $this->kernel->db->userByDet($_GET['det']);

			Skin::Header('Новый бан');
			Skin::NewBan($user['det'], $user['ip'], $user['name']);
		}
		else
		{

			Skin::Header('Бан');
			//-------------------------------------------------
			//         Add Ban Here
			//-------------------------------------------------
			if(isset($_POST['banDet']) && isset($_POST['banIP']))
			{
				$bantime = time() + $_POST['fortime'];

				$info = '';
				// Add ban
				if($_POST['checkDet'] == "true")
				{
					$this->kernel->db->addban(
					htmlspecialchars('ID'),
					htmlspecialchars($_POST['banDet']),
					intval($bantime),
					htmlspecialchars($_POST['why']) );
					$info .= "&nbsp;".$_POST['banDet'];
				}
				if($_POST['checkIP'] == "true")
				{
					$this->kernel->db->addban(
					htmlspecialchars('IP'),
					htmlspecialchars($_POST['banIP']),
					intval($bantime),
					htmlspecialchars($_POST['why']) );
					$info .= "&nbsp;".$_POST['banIP'];
				}

				// Delete from chat
				// Id came here from <form> at "first on online" and "second from newban add"
				$this->kernel->db->deleteDet($_POST['banDet']);

				// Send msg to chat
				$this->kernel->db->send('global', $_POST['banName'], '', microtime(true), 'ban', $this->kernel->banwatch($bantime));

				Skin::Info($info.' забанен.');
			}

			//-------------------------------------------------
			//         Delete Ban Here
			//-------------------------------------------------
			if(isset($_GET['deleteBan']))
			{
				$this->kernel->db->deleteban($_GET['deleteBan']);

				Skin::Info('Бан удалён.');
			}

			//-------------------------------------------------
			//         Ban List
			//-------------------------------------------------
			$result = $this->kernel->db->banlist();
			$table = array();
			$table[] = array('&nbsp;','Бан','ID\IP','Осталось','Комментарий');
			foreach($result as $k=>$row)
			{
				$i = $k+1;
				$t = $this->kernel->banwatch($row['time']); // Возвращает сколько осталось времени бана

				$table[$i][] = '<a href="javascript:ModDetBan(\''.$row['id'].'\');">Удалить</a>';
				$table[$i][] = $row['type'];
				$table[$i][] = $row['ban'];
				$table[$i][] = ( $t ? $t : 'Бан завершён.' );
				$table[$i][] = $row['comment'];
			}

			Skin::Table($table);
		}

	}

	function Send()	{}
	function Load()	{}
	function Online() {}
}

$mod = new Moderator($kernel);
$mod->Login();


